package yrpg.gmscm.rc.rcd.agreement.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.db.DB;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import yrpg.gmscm.rc.rcd.core.DBRoute;
import yrpg.gmscm.rc.rcd.enumerate.AgmApplyTypeEnum;

import java.util.EventObject;

/**
 * @author zhangjiawei
 * @date 2024/4/28 19:43
 */
public class AgmApplyChangeFormPlugin extends AbstractFormPlugin {


    @Override
    public void afterBindData(EventObject e) {
        //获取是否变更
        Long changeBill = (Long) this.getView().getFormShowParameter().getCustomParams().get("ischangebill");
        String changeType = (String) this.getView().getFormShowParameter().getCustomParams().get("change_type");
        this.getView().getPageCache().remove("ischangebill");
        if (changeBill != null || changeType != null) {
            DynamicObject agreementApply = BusinessDataServiceHelper.loadSingle(changeBill, "rm_rc_agreement_apply");
            //根据变更类型选择变更程序
            changeAgm(agreementApply, changeType);

        }
    }

    /**
     * 协议变更
     *
     * @param agreementApply 原协议
     * @param type           类型
     */
    private void changeAgm(DynamicObject agreementApply, String type) {
        this.getModel().setValue("rm_apply_type", type);
        this.getModel().setValue("rm_if_new", true);
        String billno = "";

        if (AgmApplyTypeEnum.NEW.getKey().equals(agreementApply.getString("rm_apply_type"))) {
            billno = agreementApply.getString("billno");
        } else {
            billno = agreementApply.getString("rm_agm_change_main");

        }
        this.getModel().setValue("rm_agm_change_main", billno);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        if ("save".equals(args.getOperateKey()) || "submit".equals(args.getOperateKey())) {
            if (args.getOperationResult().isSuccess()) {
                Object rmApplyType = this.getModel().getValue("rm_apply_type");
                String rmAgmChangeMain = this.getModel().getValue("rm_agm_change_main").toString();
                String billNo = this.getModel().getValue("billno").toString();
                //保存或提交成功后 且协议是变更或终止 更新其他单据状态
                if (!AgmApplyTypeEnum.NEW.getKey().equals(rmApplyType)) {
                    Object[] objects = new Object[]{
                            "0",
                            rmAgmChangeMain,
                            billNo
                    };
                    DB.update(DBRoute.rcDbRoute(),
                            "UPDATE rm_rc_agreement_apply SET frm_if_new = ?  WHERE frm_agm_change_main = ? and fbillno != ?",
                            objects);
                }
            }
        }

    }
}
