package yrpg.gmscm.rc.rcd.core.orm;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.FIELD, ElementType.ANNOTATION_TYPE})
public @interface EntityField {

    /**
     * 实体名字，表单的标识
     * @return
     */
    String value() default "";

    /**
     * 数据库的表名
     * @return
     */
    String tableFieldName() default "";

    /**
     * 是否为数据库表字段
     * <p>
     * 默认 true 存在，false 不存在
     */
    boolean exist() default true;

    /**
     * 别名
     * @return
     */
    String alias() default "";

}
