package yrpg.gmscm.rc.rcd.core.orm;

import kd.bos.dataentity.utils.StringUtils;

import java.io.Serializable;
import java.util.List;

public class EntityInfo implements Serializable {
    private static final long serialVersionUID = 1L;
    private String name;
    private String simpleName;
    private String entityName;
    private String tableName;
    private String prefix;
    private Class<?> clazz;
    private Class<?> keyType;
    private String keyName;
    private String keyEntityName;
    private String keyTableName;
    private List<FieldInfo> fields;

    private EntityInfo parent;

    public boolean hasParent() {
        return parent != null;
    }

    public EntityInfo getParent() {
        return parent;
    }

    public void setParent(EntityInfo parent) {
        this.parent = parent;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSimpleName() {
        return simpleName;
    }

    public void setSimpleName(String simpleName) {
        this.simpleName = simpleName;
    }

    public String getEntityName() {
        return entityName;
    }

    public void setEntityName(String entityName) {
        this.entityName = entityName;
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public Class<?> getClazz() {
        return clazz;
    }

    public void setClazz(Class<?> clazz) {
        this.clazz = clazz;
    }

    public List<FieldInfo> getFields() {
        return fields;
    }

    public void setFields(List<FieldInfo> fields) {
        this.fields = fields;
    }

    public Class<?> getKeyType() {
        return keyType;
    }

    public void setKeyType(Class<?> keyType) {
        this.keyType = keyType;
    }

    public String getKeyEntityName() {
        return keyEntityName;
    }

    public void setKeyEntityName(String keyEntityName) {
        this.keyEntityName = keyEntityName;
    }

    public String getKeyTableName() {
        return keyTableName;
    }

    public void setKeyTableName(String keyTableName) {
        this.keyTableName = keyTableName;
    }

    public boolean havePk() {
        return StringUtils.isNotBlank(keyEntityName);
    }

    public String getKeyName() {
        return keyName;
    }

    public void setKeyName(String keyName) {
        this.keyName = keyName;
    }

    public String getPrefix() {
        return prefix;
    }

    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }
}
