package yrpg.gmscm.rc.rcd.tools;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.org.OrgUnitServiceHelper;
import kd.bos.servicehelper.org.OrgViewType;

import java.util.Collections;
import java.util.Map;
import java.util.Objects;

/**
 * @author zhangjiawei
 * @date 2023/8/17 16:10
 */
public class GetOrgFormPatternHelper {
    /**
     * 根据当前组织获取指定形态的组织
     *
     * @param orgId       当前组织id
     * @param orgForm     组织形态编码
     * @param orgViewType 组织视图 OrgViewTypeConst
     */
    public static Long getPatternOrg(Long orgId, String orgForm, String orgViewType) {
        DynamicObject bosOrg = BusinessDataServiceHelper.loadSingle(orgId, "bos_org");
        String orgPatternNumber = bosOrg.getDynamicObject("orgpattern").getString("number");
        if (!Objects.equals(orgPatternNumber, orgForm)) {
            Map<Long, Long> orgParentMap = OrgUnitServiceHelper.getDirectSuperiorOrg(orgViewType, Collections.singletonList(orgId));
            if (Objects.equals(orgForm, "Orgform02")) {
                Map<String, Object> companyFromOrg = OrgUnitServiceHelper.getCompanyfromOrg(orgId);
                return (Long) companyFromOrg.get("id");
            }
            for (Long aLong : orgParentMap.keySet()) {
                Long parentOrg = orgParentMap.get(aLong);
                if (parentOrg != 0) {
                    getPatternOrg(parentOrg, orgForm, orgViewType);
                }else {
                    return parentOrg;
                }

            }
        } else {
            return orgId;
        }
        return 0L;
    }
}
