package yrpg.gmscm.rc.rcd.tools;

import cn.romens.cloud.xdepot.algo.RMAlgoQuery;
import com.alibaba.fastjson.JSONArray;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zhangjiawei
 * @date 2023/5/4 9:46
 */
public class RmRcConfigHelper {
//    public static boolean getConfigBoolean(String field,Object org){
//        QFilter qFilter = new QFilter("rm_org.id", QCP.equals,org);
//        DynamicObject rmRcConfigItem = BusinessDataServiceHelper.loadSingle("rm_rcd_config", field, new QFilter[]{qFilter});
//        if (rmRcConfigItem==null){
//            return false;
//        }
//        return rmRcConfigItem.getBoolean(field);
//    }
//    public static BigDecimal getConfigBigDecimal(String field, Object org){
//        QFilter qFilter = new QFilter("rm_org.id", QCP.equals,org);
//        DynamicObject rmRcConfigItem = BusinessDataServiceHelper.loadSingle("rm_rcd_config", field, new QFilter[]{qFilter});
//        if (rmRcConfigItem==null) {
//            return BigDecimal.ZERO;
//        }
//        return rmRcConfigItem.getBigDecimal(field);
//    }
    /**
     * 取配置
     * @param dataEntities 界面数据
     * @param field 要取的字段
     * @return json
     */
    public static Map<Object, JSONArray> getAllConfig(ExtendedDataEntity[] dataEntities, String field) {
        Map<Object,JSONArray> map = new HashMap<>();
        List<Object> orgList = new ArrayList<>();
        for (ExtendedDataEntity dataEntity : dataEntities) {
            DynamicObject billData = dataEntity.getDataEntity();
            DynamicObject rmAccorg = billData.getDynamicObject("rm_accorg");
            if (rmAccorg!=null) {
                orgList.add(rmAccorg.getPkValue());
            }
        }
        DataSet dataSet = RMAlgoQuery.queryDataSet("rm_rcd_config",
                field+",rm_org",
                new QFilter("rm_org", QCP.in, orgList).toArray(),
                null);
        for (Row row : dataSet) {
            Object v = row.get(field);
            Object org = row.get("rm_org");
            if (map.containsKey(org)) {
                JSONArray array = map.get(org);
                array.add(v);
                map.put(org,array);
                continue;
            }
            JSONArray newArray = new JSONArray();
            newArray.add(v);
            map.put(org,newArray);

        }
        return map;
    }
}
